# LyxEnvelope.py  Copyright Richard Harris 2001
#
# author: Richard Harris (rover@emptydog.com)
# The author releases this file under the GPL
# license. See COPYING for specifics.
#
# created: 25oct01
# change log:
#
import os, string, sys

class LyxEnvelope:

	def __init__(self):
		return

	def extractAddresses(self, lines, i):
		
		returnAddress = []
		sendToAddress = []
		while string.find(lines[i], '\\layout Send To Address') == -1:
			line = string.strip(lines[i])
			if line != "" and string.find(line, 'newline') == -1:
				returnAddress.append(line)
			i = i + 1
		i = i + 1
		while string.find(lines[i], '\\layout Signature') == -1:
			line = string.strip(lines[i])
			if line != "" and string.find(line, 'newline') == -1:
				sendToAddress.append(line)
			i = i + 1
		return [returnAddress, sendToAddress]
	
	def writeTex(self, addresses):
		f = open('tmpLyxEnvelope.tex', 'w')
		f.write('''% TeX Template for an envelope
%
% To use:
%
% tex envelope.tex
% dvips -t landscape envelope.dvi
% (put envelope in upside-down)
%
\\font\\cmssa = cmss10
\\font\\cmssc = cmss12
\\parindent -0.5 in\\nopagenumbers\\parskip 0 pt
\\hsize 9.5 in\\vsize 3.5 in
\\voffset 1.25 in
\\cmssa

''')
		for line in addresses[0]:
			f.write(line)
			f.write('\n\n')
		f.write('''\\vskip 1.5 in\\vskip 15 pt\\parindent 3 in

''')
		for line in addresses[1]:
			f.write(line)
			f.write('\n\n')
		f.write('\\end')
		f.close()
			
	def makeEnvelope(self, file):
		# open lyx file and read it up
		f = open(file, 'r')
		lines = f.readlines()
		f.close()
		# find the \layout My Address line and extract return address
		# find the \layout Send To Address and extract recipient's address
		done = 0
		for i in range(0, len(lines)):
			if string.find(lines[i], '\\layout My Address') == 0:
				addresses = self.extractAddresses(lines, i + 1)
				done = 1
			if done:
				break
			i = i + 1
		# write the .tex file substituting in the addresses
		self.writeTex(addresses)
		# run tex on the .tex file
		os.system('tex tmpLyxEnvelope.tex')
		# run dvips on the tex's .dvi output
		os.system('dvips -t landscape tmpLyxEnvelope.dvi')
		print `len(sys.argv)`
		if len(sys.argv) > 1:
			os.system('rm tmpLyxEnvelope.tex')
		os.system('rm tmpLyxEnvelope.dvi')
		os.system('rm tmpLyxEnvelope.log')

#------------------main
l = LyxEnvelope()
l.makeEnvelope(sys.argv[1])




